#include "udx_api.hpp"                               	// For extensions API
using namespace std;                                 	// Everything in std
using namespace udx2;                                	// Everything in udx
 
//The following UDA computes the arithmetic mean of a list of long integers"
struct average : Aggregate
{
  long m_sum = 0;
  long m_cnt = 0;
 
  void accumulate(const Row& r)
  {
    m_sum += r.getLong(0);
    m_cnt += 1;
  }
 
  void save(Row& r)
  {
    r.setLong(0,m_sum)
     .setLong(1,m_cnt);
  }
 
  void merge(const Row& r)
  {
    m_sum += r.getLong(0);
    m_cnt += r.getLong(1);
  }
 
  void result(Row& r)
  {
    if (m_cnt)
      r.setDouble(0,double(m_sum)/m_cnt);
  }
 
};
extern "C" ExtensionFactory* udx_average() { return new FactoryFor<average>(); }
